import { DataTypes, Model } from "sequelize";
import { sequelize } from "../database/database";

export class WifiScan extends Model {
  public lp_ttn_end_device_uplinks_id!: string;
  public wifi_scan_id!: string;
  public mac!: string;
  public rssi!: number;
  public created_at_utc!: Date;
  public updated_at_utc!: Date;
}

WifiScan.init(
  {
    wifi_scan_id: {
      type: DataTypes.UUID,
      defaultValue: DataTypes.UUIDV4,
      primaryKey: true,
      allowNull: false,
    },
    lp_ttn_end_device_uplinks_id: {
      type: DataTypes.UUID,
      allowNull: false,
    },
    mac: {
      type: DataTypes.STRING,
      allowNull: false,
    },
    rssi: {
      type: DataTypes.NUMBER,
      allowNull: false,
    },
    created_at_utc: {
      type: DataTypes.DATE,
      defaultValue: DataTypes.NOW,
      allowNull: false,
    },
    updated_at_utc: {
      type: DataTypes.DATE,
      defaultValue: DataTypes.NOW,
      allowNull: false,
    },
  },
  {
    sequelize,
    modelName: "WifiScan",
    tableName: "wifi_scan",
    timestamps: false,
  }
);
